﻿using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Data;
using System.Configuration;
using System.Web.Security;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;

public partial class Default : System.Web.UI.Page
{
    private const string MessageTemplate = "You chose to explore the city of {0} in {1}, {2}";

    #region Data
    private DataTable GetContinents()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("ContinentID", typeof(int));
        dt.Columns.Add("Name", typeof(string));
        dt.Rows.Add("1", "Australia");
        dt.Rows.Add("2", "Asia");
        return dt;
    }
    private DataTable GetCountries()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("CountryID", typeof(int));
        dt.Columns.Add("Name", typeof(string));
        dt.Columns.Add("ContinetID", typeof(int));
        dt.Rows.Add("1", "Australia", 1);
        dt.Rows.Add("2", "New Zeland", 1);
        dt.Rows.Add("3", "China", 2);
        dt.Rows.Add("4", "India", 2);
        return dt;
    }
    private DataTable GetCities()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("CityID", typeof(int));
        dt.Columns.Add("Name", typeof(string));
        dt.Columns.Add("CountryID", typeof(int));

        dt.Rows.Add("1", "Sydney", 1);
        dt.Rows.Add("2", "Wellington", 2);
        dt.Rows.Add("4", "Bejing", 3);
        dt.Rows.Add("5", "Delhi", 4);
        dt.Rows.Add("6", "Mumbai", 4);

        return dt;
    }
    #endregion
    #region Methods
    private void LoadContinents()
    {
        RadComboBox1.DataTextField = "Name";
        RadComboBox1.DataValueField = "ContinentID";
        RadComboBox1.DataSource = GetContinents();
        RadComboBox1.DataBind();
    }
    private void LoadCountries(string p)
    {
        var table = GetCountries()
            .AsEnumerable()
            .Where(r => r.Field<int>("CountryID") == Int32.Parse(p))
            .AsDataView()
            .ToTable();

        RadComboBox2.DataTextField = "Name";
        RadComboBox2.DataValueField = "CountryID";
        RadComboBox2.DataSource = table;
        RadComboBox2.DataBind();
    }
    private void LoadCities(string p)
    {
        var table = GetCities()
            .AsEnumerable()
            .Where(r => r.Field<int>("CityID") == Int32.Parse(p))
            .AsDataView()
            .ToTable();

        RadComboBox3.DataTextField = "Name";
        RadComboBox3.DataValueField = "CityID";
        RadComboBox3.DataSource = table;
        RadComboBox3.DataBind();
    }
    #endregion
    #region Events
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
            // Fill the continents combo.
            LoadContinents();
    }
    protected void RadComboBox1_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
    {
        RadComboBox2.Text = "";
        RadComboBox3.Items.Clear();
        RadComboBox3.Text = "";
        LoadCountries(e.Value);
    }
    protected void RadComboBox2_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
    {
        LoadCities(e.Value);
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        Literal1.Text = string.Empty;

        if (RadComboBox1.SelectedIndex > 0)
            Literal1.Text = string.Format(MessageTemplate, RadComboBox3.Text, RadComboBox2.Text, RadComboBox1.Text);
    }
    #endregion
}
